From 107d8fe556c8a308fecb1d03e2e62619be1da46b Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Mar 10 2017 18:12:49 +0000
Subject: [PATCH 794/1001] Auto-save the settings


---

diff --git a/hubs/static/client/app/core/HubConfig.jsx b/hubs/static/client/app/core/HubConfig.jsx
index 9040e46..346392e 100644
--- a/hubs/static/client/app/core/HubConfig.jsx
+++ b/hubs/static/client/app/core/HubConfig.jsx
@@ -56,31 +56,29 @@ export default class HubConfig extends React.Component {
     this.state = {
       hubConfig: {},
       generalConfig: {},
+      dirty: false,
       error: null,
       loading: false
     }
     this.serverRequest = null;
-    this.handleSubmit = this.handleSubmit.bind(this);
     this.handleChange = this.handleChange.bind(this);
     this.loadState = this.loadState.bind(this);
     this.pushState = this.pushState.bind(this);
-    //this.componentWillUpdate = this.componentWillUpdate.bind(this);
   }
 
-	loadState() {
-    this.setState({loading: true});
-    this.serverRequest = $.ajax({
+  getRequestParams() {
+    return {
       url: this.props.url,
-      method: 'GET',
       dataType: 'json',
       cache: false,
       success: function(data) {
         this.setState({
           hubConfig: data.result.hub,
           generalConfig: data.result.general,
+          dirty: false,
           error: null,
           loading: false
-				});
+        });
       }.bind(this),
       error: function(xhr, status, err) {
         console.error(this.props.url, status, err.toString());
@@ -89,52 +87,42 @@ export default class HubConfig extends React.Component {
           loading: false
         });
       }.bind(this)
-    });
+    }
+  }
+
+  loadState() {
+    var params = this.getRequestParams();
+    params.method = "GET";
+    this.setState({loading: true});
+    this.serverRequest = $.ajax(params);
   }
 
   pushState() {
+    var params = this.getRequestParams();
+    params.method = "POST";
+    params.data = this.state.hubConfig;
     this.setState({loading: true});
-    this.serverRequest = $.ajax({
-      url: this.props.url,
-      method: 'POST',
-      data: this.state.hubConfig,
-      dataType: 'json',
-      cache: false,
-      success: function(data) {
-        this.setState({
-          hubConfig: data.result.hub,
-          generalConfig: data.result.general,
-          error: null,
-          loading: false
-        });
-      }.bind(this),
-      error: function(xhr, status, err) {
-        console.error(this.props.url, status, err.toString());
-        this.setState({
-          error: err.toString(),
-          loading: false
-        });
-      }.bind(this)
-    });
+    this.serverRequest = $.ajax(params);
   }
 
   handleChange(e) {
     var config = this.state.hubConfig;
     config[e.target.name] = e.target.value;
-    this.setState({hubConfig: config});
-  }
-
-  handleSubmit(e) {
-    e.preventDefault();
-    this.pushState();
+    this.setState({
+      hubConfig: config,
+      dirty: true,
+    }, function() {
+      window.clearTimeout(this.pushTimer);
+      this.pushTimer = window.setTimeout(this.pushState, 1000);
+    });
   }
 
-	componentDidMount() {
-		this.loadState();
+  componentDidMount() {
+    this.loadState();
   }
 
-	componentWillUnmount() {
-		if (this.serverRequest) { this.serverRequest.abort(); }
+  componentWillUnmount() {
+    if (this.serverRequest) { this.serverRequest.abort(); }
   }
 
   render() {
@@ -142,13 +130,17 @@ export default class HubConfig extends React.Component {
       <IntlProvider locale={navigator.language}>
         <div className="modal-dialog modal-lg" role="document">
           <div className="modal-content">
-            <form
-              method="post" action={this.props.url}
-              onSubmit={this.handleSubmit}
-              ref={(ref) => this.formDom = ref}
-              >
+            <form method="post" action={this.props.url}>
               <div className="modal-header">
-                <button type="button" className="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
+                <button
+                  type="button"
+                  className="close"
+                  data-dismiss="modal"
+                  aria-label="Close"
+                  disabled={this.state.dirty}
+                  >
+                  <span aria-hidden="true">&times;</span>
+                </button>
                 <h4 className="modal-title">
                   <FormattedMessage {...messages.title} />
                 </h4>
@@ -192,14 +184,10 @@ export default class HubConfig extends React.Component {
                   type="button"
                   className="btn btn-default"
                   data-dismiss="modal"
-                  disabled={this.state.loading}
+                  disabled={this.state.dirty}
                   >
                   <FormattedMessage {...messages.close} />
                 </button>
-                <button type="button" className="btn btn-primary"
-                        onClick={this.handleSubmit}>
-                  <FormattedMessage {...messages.save_changes} />
-                </button>
                 { this.state.error &&
                   <div
                     className="alert alert-danger" role="alert"
diff --git a/hubs/static/client/app/core/HubConfigPanel.jsx b/hubs/static/client/app/core/HubConfigPanel.jsx
index 4990dd3..517042f 100644
--- a/hubs/static/client/app/core/HubConfigPanel.jsx
+++ b/hubs/static/client/app/core/HubConfigPanel.jsx
@@ -85,7 +85,7 @@ export class GeneralPanel extends React.Component {
             id="hub-settings-general-summary"
             disabled={stillLoading}
             onChange={this.props.handleChange}
-            value={this.props.hubConfig.summary}
+            value={this.props.hubConfig.summary || ""}
             />
         </div>
         <div className="form-group">
@@ -98,7 +98,7 @@ export class GeneralPanel extends React.Component {
             disabled={stillLoading}
             min="1" max="11"
             onChange={this.props.handleChange}
-            value={this.props.hubConfig.left_width}
+            value={this.props.hubConfig.left_width || ""}
             />
         </div>
         <div className="form-group">
@@ -110,7 +110,7 @@ export class GeneralPanel extends React.Component {
             id="hub-settings-general-avatar"
             disabled={stillLoading}
             onChange={this.props.handleChange}
-            value={this.props.hubConfig.avatar}
+            value={this.props.hubConfig.avatar || ""}
             />
         </div>
       </div>

